routes/web.php
<?php

use Illuminate\Support\Facades\Artisan;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/linkstorage', function () {
	Artisan::call('storage:link');
});

Route::get('/', function () {
	return view('auth.login');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');
Auth::routes();

Route::get('/home', 'HomeController@index')->name('home')->middleware('auth');

Route::group(['middleware' => 'auth'], function () {	
	Route::get('profile', ['as' => 'profile.edit', 'uses' => 'ProfileController@edit']);
	Route::put('profile', ['as' => 'profile.update', 'uses' => 'ProfileController@update']);
	Route::put('profile/password', ['as' => 'profile.password', 'uses' => 'ProfileController@password']);
	Route::group(['middleware' => ['permission:config']], function () {
		Route::resource('user', 'UserController', ['except' => ['show']]);	
	});
	Route::resource('file', 'FileController');
	
	//Route::get('searchuser', 'UserController@search')->name('searchuser');		
	Route::resource('patient', 'PatientController');
	Route::resource('history', 'HistoryController');
});

app/Patient.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\SoftDeletes;
use Spatie\Image\Manipulations;
use Spatie\MediaLibrary\HasMedia\HasMedia;
use Spatie\MediaLibrary\HasMedia\HasMediaTrait;
use Spatie\MediaLibrary\Models\Media;

class Patient extends Model implements HasMedia
{
    use SoftDeletes;
    use HasMediaTrait {
        getFirstMediaUrl as protected getFirstMediaUrlTrait;
    }

    protected $fillable = [
        'name',
        'last_name',
        'mother_last_name',
        'email',
        'phone',
        'address'
    ];

    protected $appends = [
        'full_name',
        'has_media'
    ];

    public function getFullName()
    {
        return $this->name . ' ' . $this->last_name . ' ' . $this->mother_last_name;
    }

    public function getFullNameAttribute()
    {
        return $this->name . ' ' . $this->last_name . ' ' . $this->mother_last_name;
    }

    public function medicalHistories()
    {
        return $this->hasMany('App\MedicalHistory')->orderBy('created_at', 'ASC');
    }

    /**
     * @param Media|null $media
     * @throws \Spatie\Image\Exceptions\InvalidManipulation
     */
    public function registerMediaConversions(Media $media = null)
    {
        $this->addMediaConversion('thumb')
            ->fit(Manipulations::FIT_CROP, 200, 200)
            ->sharpen(10);

        $this->addMediaConversion('icon')
            ->fit(Manipulations::FIT_CROP, 100, 100)
            ->sharpen(10);
    }

    /**
     * to generate media url in case of fallback will
     * return the file type icon
     * @param string $conversion
     * @return string url
     */
    public function getFirstMediaUrl($collectionName = 'default', $conversion = '')
    {
        $url = $this->getFirstMediaUrlTrait($collectionName);
        if ($url) {
            $array = explode('.', $url);
            $extension = strtolower(end($array));
            if (in_array($extension, config('medialibrary.extensions_has_thumb'))) {
                return asset($this->getFirstMediaUrlTrait($collectionName, $conversion));
            } else {
                return asset(config('images/icons') . '/' . $extension . '.png');
            }
        } else {
            return asset('avatar/default.png');
        }        
    }

    /**
     * Add Media to api results
     * @return bool
     */
    public function getHasMediaAttribute()
    {
        return $this->hasMedia('image') ? true : false;
    }
}

app/Http/Controllers/PatientController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\PatientRequest;
use App\Patient;
use App\Upload;
use Exception;
use Illuminate\Contracts\Session\Session as SessionSession;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Session;
use Prettus\Validator\Exceptions\ValidatorException;

class PatientController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index(Request $request)
    {
        if ($request) {
            $search = trim($request->get('searchText'));
            $patients = Patient::withTrashed()->where('name', 'LIKE', '%' . $search . '%')
                ->orWhere('last_name', 'LIKE', '%' . $search . '%')
                ->orWhere('mother_last_name', 'LIKE', '%' . $search . '%')
                ->orWhere('phone', 'LIKE', '%' . $search . '%')
                ->orWhere('email', 'LIKE', '%' . $search . '%')
                ->orWhere('full_name', 'LIKE', '%' . $search . '%')
                ->orderBy('last_name', 'ASC')
                ->orderBy('mother_last_name', 'ASC')
                ->paginate(10);
            return view('patients.index', ['patients' => $patients, 'searchText' => $search]);
        }
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('patients.add');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(PatientRequest $request)
    {
        try {
            $patient = new Patient();
            $input = $request->all();
            $patient->name = $input['name'];
            $patient->last_name = $input['last_name'];
            $patient->mother_last_name = $input['mother_last_name'];
            // $patient->birthday = $input['birthday'];
            $patient->age = $input['age'];
            $patient->email = $input['email'];
            $patient->phone = $input['phone'];
            $patient->address = $input['address'];

            if (isset($input['image']) && $input['image']) {
                $patient->addMediaFromRequest('image')->toMediaCollection('image');
            }
            $patient->save();

            Session::flash('status', 'Paciente creado exitosamente');
        } catch (Exception $e) {
            //Flash::error($e->getMessage());
            Session::flash('status', 'Error generado ' . $e->getMessage());
            //return back()->withErrors('your error message');

        }

        return redirect('patient');
    }

    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $patient = Patient::withTrashed()->where('id', $id)->first();
        return view('patients.evolution', ['patient' => $patient]);
    }

    public function evolution ($id) {
        $patient = Patient::find($id);
        return view('patients.evolution', ['patient' => $patient]);
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $patient = Patient::find($id);
        return view('patients.edit', ['patient' => $patient]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(PatientRequest $request, $id)
    {
        try {
            $patient = Patient::find($id);
            $input = $request->all();
            $patient->name = $input['name'];
            $patient->last_name = $input['last_name'];
            $patient->mother_last_name = $input['mother_last_name'];
            // $patient->birthday = $input['birthday'];
            $patient->age = $input['age'];
            $patient->email = $input['email'];
            $patient->phone = $input['phone'];
            $patient->address = $input['address'];

            if (isset($input['image']) && $input['image']) {
                $patient->addMediaFromRequest('image')->toMediaCollection('image');
            }
            $patient->update($input);

            Session::flash('status', 'Paciente actualizado exitosamente');
        } catch (Exception $e) {            
            Session::flash('status', 'Error generado ' . $e->getMessage());            
        }

        return redirect('patient');

    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $patient = Patient::withTrashed()->where('id', $id)->first();        
        if (empty($patient)) {
            Session::flash('status', 'Paciente no encontrado');
            return redirect(route('patient.index'));
        }

        if (empty($patient->deleted_at)) {
            $patient->delete($id);
            Session::flash('status', 'Paciente dado de baja exitosamente');
        } else {         
            $patient->restore();
            Session::flash('status', 'paciente activado exitosamente');
        }        
        
        return redirect(route('patient.index'));
    }
}

resources/views/patients/edit.blade.php
@extends('layouts.app', ['activePage' => 'patients', 'titlePage' => 'Editar paciente'])

@section('content')
<div class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <!-- <form method="post" action="{{route('patient.update', $patient->id)}}" autocomplete="off" enctype="multipart/form-data" class="form-horizontal"> -->
                <form method="post" action="{{route('patient.update', $patient->id)}}" autocomplete="off" enctype="multipart/form-data" class="form-horizontal">
                    @csrf
                    @method('put')
                    <div class="card ">
                        <div class="card-header card-header-primary">
                            <p class="card-category">Informacion del paciente</p>
                        </div>
                        <div class="card-body">
                            @if (session('status'))
                            <div class="row">
                                <div class="col-sm-12">
                                    <div class="alert alert-danger">
                                        <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                            <i class="material-icons">close</i>
                                        </button>
                                        <span>{{ session('status') }}</span>
                                    </div>
                                </div>
                            </div>
                            @endif
                            <div class="row">
                                <div class="col-md-8 col-xs-12">
                                    <div class="row">
                                        <label class="col-sm-2 col-form-label">Nombre</label>
                                        <div class="col-sm-7">
                                            <div class="form-group{{ $errors->has('name') ? ' has-danger' : '' }}">
                                                <input class="form-control{{ $errors->has('name') ? ' is-invalid' : '' }}" name="name" id="input-name" type="text" placeholder="Nombre" value="{{ $patient->name }}" required="true" aria-required="true" />
                                                @if ($errors->has('name'))
                                                <span id="name-error" class="error text-danger" for="input-name">{{ $errors->first('name') }}</span>
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <label class="col-sm-2 col-form-label">Apellido Paterno</label>
                                        <div class="col-sm-7">
                                            <div class="form-group{{ $errors->has('last_name') ? ' has-danger' : '' }}">
                                                <input class="form-control{{ $errors->has('last_name') ? ' is-invalid' : '' }}" name="last_name" id="input-last-name" type="text" placeholder="Apellido paterno" value="{{ $patient->last_name }}" required="true" aria-required="true" />
                                                @if ($errors->has('last_name'))
                                                <span id="last-name-error" class="error text-danger" for="input-last-name">{{ $errors->first('last_name') }}</span>
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <label class="col-sm-2 col-form-label">Apellido Materno</label>
                                        <div class="col-sm-7">
                                            <div class="form-group{{ $errors->has('mother_last_name') ? ' has-danger' : '' }}">
                                                <input class="form-control{{ $errors->has('mother_last_name') ? ' is-invalid' : '' }}" name="mother_last_name" id="input-mother-last-name" type="text" placeholder="Apellido materno" value="{{ $patient->mother_last_name }}" required="true" aria-required="true" />
                                                @if ($errors->has('mother_last_name'))
                                                <span id="mother-last-name-error" class="error text-danger" for="input-mother-last-name">{{ $errors->first('mother_last_name') }}</span>
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                    <label class="col-sm-2 col-form-label">Edad</label>
                                    <div class="col-sm-7">
                                        <div class="form-group{{ $errors->has('age') ? ' has-danger' : '' }}">
                                            <input class="form-control{{ $errors->has('age') ? ' is-invalid' : '' }}" name="age" id="input-age" type="number" placeholder="Edad" value="{{ $patient->age }}" />
                                            @if ($errors->has('age'))
                                            <span id="email-error" class="error text-danger" for="input-age">{{ $errors->first('age') }}</span>
                                            @endif
                                        </div>
                                    </div>
                                </div>
                                    <!-- <div class="row">
                                        <label class="col-sm-2 col-form-label">Fecha nacimiento</label>
                                        <div class="col-sm-7">
                                            <div class="form-group{{ $errors->has('birthday') ? ' has-danger' : '' }}">
                                                <input class="form-control" name="birthday" id="input-birthday" type="date" placeholder="Fecha nacimiento" value="{{ $patient->birthday }}" />
                                            </div>
                                        </div>
                                    </div> -->
                                    <div class="row">
                                        <label class="col-sm-2 col-form-label">Correo</label>
                                        <div class="col-sm-7">
                                            <div class="form-group{{ $errors->has('email') ? ' has-danger' : '' }}">
                                                <input class="form-control{{ $errors->has('email') ? ' is-invalid' : '' }}" name="email" id="input-email" type="email" placeholder="Correo" value="{{ $patient->email }}" />
                                                @if ($errors->has('email'))
                                                <span id="email-error" class="error text-danger" for="input-email">{{ $errors->first('email') }}</span>
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <label class="col-sm-2 col-form-label">Teléfono</label>
                                        <div class="col-sm-7">
                                            <div class="form-group{{ $errors->has('phone') ? ' has-danger' : '' }}">
                                                <input class="form-control{{ $errors->has('phone') ? ' is-invalid' : '' }}" name="phone" id="input-phone" type="tel" maxlength="10" minlength="10" placeholder="Teléfono" value="{{ $patient->phone }}"/>
                                                @if ($errors->has('phone'))
                                                <span id="phone-error" class="error text-danger" for="input-phone">{{ $errors->first('phone') }}</span>
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <label class="col-sm-2 col-form-label">Dirección</label>
                                        <div class="col-sm-7">
                                            <div class="form-group{{ $errors->has('address') ? ' has-danger' : '' }}">
                                                <input class="form-control{{ $errors->has('address') ? ' is-invalid' : '' }}" name="address" id="input-address" type="text" placeholder="Dirección" value="{{ $patient->address }}" />
                                                @if ($errors->has('address'))
                                                <span id="address-error" class="error text-danger" for="input-address">{{ $errors->first('address') }}</span>
                                                @endif
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <div class="col-md-4 col-xs-12">
                                    <div class="form-group form-file-upload form-file-multiple">
                                        <input type="file" name="image" id="image" accept="image/*" class="inputFileHidden file">
                                        <div class="input-group">
                                            <input id="file" type="text" class="form-control inputFileVisible" placeholder="Cargar imagen">
                                            <span class="input-group-btn">
                                                <button type="button" class="browse btn btn-fab btn-round btn-primary">
                                                    <i class="material-icons">attach_file</i>
                                                </button>
                                            </span>
                                        </div>
                                        <img id="preview" class="img-thumbnail" src="{{$patient->getFirstMediaUrl('image', 'thumb')}}" alt="{{$patient->name}}">
                                    </div>
                                </div>
                            </div>

                        </div>
                        <div class="card-footer ml-auto mr-auto">
                            <a class="btn btn-danger float-right" href="{{route('patient.index')}}">Volver a la lista</a>
                            <button type="submit" class="btn btn-primary">Guardar</button>
                        </div>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/patients/index.blade.php
@extends('layouts.app', ['activePage' => 'patients', 'titlePage' => 'Lista de pacientes'])

@section('content')
<div class="content">
    <div class="container-fluid">
        <div class="row">
            <div class="col-md-12">
                <div class="card">
                    <div class="card-header card-header-primary">
                        <h4 class="card-title ">Pacientes</h4>
                        <p class="card-category"> Aqui puedes administrar tus pacientes</p>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-6 col-xs-12 _text-right">
                                <a href="{{route('patient.create')}}" class="btn btn-sm btn-primary">Agregar paciente</a>
                            </div>
                            <div class="col-md-6 col-xs-12 float-right">
                                @include('patients.search')
                            </div>
                        </div>
                        @if (session('status'))
                        <div class="row">
                            <div class="col-sm-12">
                                <div class="alert alert-success">
                                    <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                                        <i class="material-icons">close</i>
                                    </button>
                                    <span>{{ session('status') }}</span>
                                </div>
                            </div>
                        </div>
                        @endif
                        <div class="table-responsive">
                            <table class="table">
                                <thead class=" text-primary">
                                    <th>Imagen</th>
                                    <th>
                                        Apellido Paterno
                                    </th>
                                    <th>
                                        Apellido Materno
                                    </th>
                                    <th>
                                        Nombre (s)
                                    </th>
                                    <th>Edad</th>
                                    <th>
                                        Email
                                    </th>
                                    <th>
                                        Teléfono
                                    </th>
                                    <th>
                                        Dirección
                                    </th>
                                    <th>Acciones</th>
                                </thead>
                                <tbody>
                                    @foreach ($patients as $patient)
                                    <tr>
                                        <td>
                                            <img class="img-circle elevation-2" style="width:32px" src="{{$patient->getFirstMediaUrl('image', 'thumb')}}" alt="default">
                                        </td>
                                        <td>{{$patient->last_name}}</td>
                                        <td>{{$patient->mother_last_name}}</td>
                                        <td>{{$patient->name}}</td>
                                        <td>{{$patient->age}}</td>
                                        <td>{{$patient->email}}</td>
                                        <td>{{$patient->phone}}</td>
                                        <td>{{$patient->address}}</td>
                                        <td class="td-actions text-right">
                                            @can('patient.evolution')
                                            <a rel="tooltip" class="btn btn-info btn-link" href="{{ route('patient.show', $patient->id) }}" data-original-title="" title="Evolución">
                                                <i class="material-icons">note_add</i>
                                                <div class="ripple-container"></div>
                                            </a>
                                            @endcan
                                            @if(empty($patient->deleted_at))
                                            @can('patient.edit')
                                            <a rel="tooltip" class="btn btn-info btn-link" href="{{ route('patient.edit', $patient->id) }}" data-original-title="" title="Editar">
                                                <i class="material-icons">edit</i>
                                                <div class="ripple-container"></div>
                                            </a>
                                            @endcan
                                            @can('patient.destroy')
                                            <a rel="tooltip" class="btn btn-warning btn-link" href="" data-target="#modal-delete-{{$patient->id}}" data-toggle="modal" title="Baja">
                                                <i class="material-icons">close</i>
                                                <div class="ripple-container"></div>
                                            </a>
                                            @endcan
                                            @else
                                            @can('patient.active')                                           
                                            <a rel="tooltip" class="btn btn-warning btn-link" href="" data-target="#modal-delete-{{$patient->id}}" data-toggle="modal" title="Activar">
                                                <i class="material-icons">done_all</i>
                                                <div class="ripple-container"></div>
                                            </a>
                                            @endcan
                                            @endif
                                        </td>
                                    </tr>
                                    @include('patients.modal')
                                    @endforeach
                                </tbody>
                            </table>
                            {!!$patients->render()!!}
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/patients/modal-history.blade.php
<div class="modal fade modal-slide-in-right" id="modal-history-{{$patient->id}}" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title">Agregar evolución </h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">×</span>
                </button>
            </div>
            {{Form::Open(array('id' => 'saveHistory', 'autocomplete' => 'off', 'action'=>array('HistoryController@store'),'method'=>'post'))}}
            <div class="modal-body">
                <input type="hidden" name="patient_id" value="{{$patient->id}}">
                <div class="col-12">
                    <div class="form-group bmd-form-group">
                        <label for="title" class="bmd-label-floating"> Titulo </label>
                        <input type="text" class="form-control" name="title" id="title" maxlength="100">
                    </div>
                    <div class="form-group bmd-form-group">
                        <label for="right_eye" class="bmd-label-floating"> OD</label>
                        <input type="text" class="form-control" name="right_eye" id="right_eye" maxlength="100">
                    </div>
                    <div class="form-group bmd-form-group">
                        <label for="left_eye" class="bmd-label-floating"> OI</label>
                        <input type="text" class="form-control" name="left_eye" id="left_eye" maxlength="100">
                    </div>
                    <div class="form-group bmd-form-group">
                        <label for="right_rise" class="bmd-label-floating"> AD </label>
                        <input type="text" class="form-control" name="right_rise" id="right_rise" maxlength="100">
                    </div>
                    <div class="form-group bmd-form-group">
                        <label for="left_rise" class="bmd-label-floating"> DI </label>
                        <input type="text" class="form-control" name="left_rise" id="left_rise" maxlength="100">
                    </div>
                    <div class="form-group bmd-form-group">
                        <label for="lens_type" class="bmd-label-floating"> Tipo de lente </label>
                        <input type="text" class="form-control" name="lens_type" id="lens_type" maxlength="100">
                    </div>
                    <div class="form-group bmd-form-group">
                        <label for="comments" class="bmd-label-floating"> Comentarios *</label>
                        <textarea class="form-control" name="comments" id="comments" cols="30" rows="5" required="true" aria-required="true" aria-invalid="true"></textarea>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                    <button type="submit" id="btn-save-history" class="btn btn-success">Guardar</button>
                </div>
                {{Form::Close()}}

            </div>
        </div>
    </div>

resources/views/patients/search.blade.php
{!! Form::open(array('url'=>'patient','method'=>'GET','autocomple'=>'of','role'=>'search')) !!}
<div class="form-group row">
	<div class="col-md-12">
		<div class="input-group">	            
            <input class="form-control" name="searchText" id="input-search" type="text" placeholder="Buscar paciente..." value="{{$searchText}}" />			
			<button type="submit" class="btn btn-primary btn-sm">
                <i class="material-icons">search</i>
            </button>
		</div>
	</div>
</div>
{!! Form::close() !!}